#ifndef _CONVERTMAP_H
#define _CONVERTMAP_H

/**  convertMap.h
Functions for converting  from one Map form to another 
and extracting smaller maps. There are four polymorphic
functions.   The general format is

convertMap(MapType * source,MapType * target, Point ul, Point lr)

MapTypes can be - BitMap, RLEMap, or VRLEMap
source - the map to be converted from
target - The map to be converted to.  Memory will be allocated
         for target's contents. 
ul and lr mark a range to copy.   If either are the global var NOPNT,
the entire map will  be copied.

Functions return a MapStatus which will be VALID or OTHERERROR
if there was an error in the conversion.  An error might be due
to a user specifying an out of range ul and lr.

**************************************************************/
#include "system.h"
#include "Point.h"
#include "BitMap.h"
#include "RLEPair.h"
#include "RLEMap.h"
#include "Point.h"



/****  BitMap Conversion ***/
MapStatus convertMap(BitMap * source,  BitMap * target, Point ul = 0, 
		     Point lr= 0);
MapStatus convertMap(BitMap * source,  RLEMap * target, Point ul= 0, 
		     Point lr= 0);


/**** RLEMap Conversion   ***/
MapStatus convertMap(RLEMap * source,  BitMap * target, Point ul = 0,
		      Point lr = 0);
MapStatus convertMap(RLEMap * source,  RLEMap * target, Point ul= 0,
		     Point lr= 0);
#endif









